unit MainUnit;

{
Object Cleaner 1.01

The ObjectCleaner is a *very* simple program
that I wrote to clean up my Delphi application
directories and zip them up for backup.  Since
I seemed to be at odds at many occasions when 
to delete what, where and when, I left the
option to clean up in the air.

The project requires the use of a unit called
DIRSCAN.PAS that I cannot for the life of me
remember where I got, a simple unit I developed
to give the days and times, and the InfoZip for
Delphi components.  (I've included the InfoZip
ZipDll.dll just in case along with the 
Readme.txt from the distribution in case if 
you need to find the whole thing).

To use this program, simply select the directory
that you wish to clean/backup and select if you
wish to recurse the directories (which applies
to the deletion of files AND zipping) and if you
wish to create a zip file.  The files deleted with
be deleted (*NOT* sent to the recycle bin!!!!)
based upon the filter given.  If the zipping option
is used, then the zip file will take the name of the
directory that was zipped and a date/time stamp.
(If for some reason you zip the root directory, the 
name will be "ROOT").  That's it.

The command line options available are '/path' which
defaults the program to start in a specific directory
(such as your application directory).  or you can use
'batchmode' which will run one cleanup/backup and then
exit.  '/batchmode' must be folled with path, filter,
true/false (Subdirectories), and true/false (zip).  You
cannot use both at the same time.  An example of 
Batchmode is "/batchmode C:\app32 *.dcu;*.~* true true".

I give this program as freeware with no assurances
or warentees involved.  Use at your own risk. 
Anyone can use this code for any project you wish,
however I humbly request that my name and email
address be given somewhere in the credits.

Cheers

Version 1.03

I've can't seem to quit fiddling with this thing.  I've 
added a function that I call "ZipCasting."  What I did
is that if you want the zip file to always goto some
other location--like a backup folder--you just set the
Zipcast folder, and then set the "Use ZipCast Folder"
menu option.  If you like leaving it in the same place,
then just click the "Use Default Folder."  Of course
you can also have a dialog popup to allow you to pick the
place you want the zip file to be placed.

I've updated the /batchmode parameters to include the
zipcasting boolean, so it is now: "/batchmode c:\app32
*.dcu;*.~* true true false" or some such combination.

I've included a great deal of information along with the
source code.  I'm hoping that even if you don't like the
application, you might like the example source code.

Happy Motering


Version 1.04

Okay... Well, the only thing I did wrong (but it's important)
is that I didn't deallocate the memory allocated by the call
to a shell function.  If you look in the simpleutils I've changed
that portion.

Baaweepgranaweepminibaulm!

Joseph Wilcock
Coockoo@hotmail.com
http://msnhomepages.talkcity.com/RedmondAve/coockoo/
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, Outline, DirOutln, Buttons, ExtCtrls, ZipMstr, JwStrRes, Menus;

type
  TMainForm = class(TForm)
    DriveBox: TDriveComboBox;
    cbFilter: TComboBox;
    cbIncludeSub: TCheckBox;
    Bevel1: TBevel;
    btGo: TBitBtn;
    btClose: TBitBtn;
    AppLabel: TLabel;
    DirectoryOutline: TDirectoryListBox;
    ZipControl: TZipMaster;
    cbZipdir: TCheckBox;
    lbTotal: TLabel;
    lbHint: TLabel;
    PopupMenu1: TPopupMenu;
    SetZipcastFolder1: TMenuItem;
    Zipcasting1: TMenuItem;
    UseZipcastFolder1: TMenuItem;
    N1: TMenuItem;
    PromptforZipcastFolder1: TMenuItem;
    UseDefaultFolder1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Ziponefileperfolder1: TMenuItem;
    N3: TMenuItem;
    Version1: TMenuItem;
    CommandLineParameters1: TMenuItem;
    Help1: TMenuItem;
    procedure DriveBoxChange(Sender: TObject);
    procedure btGoClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbFilterKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ZipControlProgress(Sender: TObject; ProgrType: ProgressType;
      Filename: String; FileSize: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SetZipcastFolder1Click(Sender: TObject);
    procedure UseZipcastFolder1Click(Sender: TObject);
    procedure Ziponefileperfolder1Click(Sender: TObject);
    procedure Version1Click(Sender: TObject);
    procedure CommandLineParameters1Click(Sender: TObject);
  private
    { Private declarations }
    FTotals: LongInt;
    FBatchMode: Boolean;
    FZipCastDir: String;
    Function ActOnFiles( Const path: String; Const SRec: TSearchRec ): Boolean;
    Function OnePerDir( Const path: String; Const SRec: TSearchRec ): Boolean;
    Procedure ZipDir;
    Procedure ZipupOnePerDir;
    Procedure OnHint( Sender: TObject );
    Procedure SaveToIniFile;
    Procedure ReadFromIniFile;
    procedure SetBatchMode(const Value: Boolean);
    procedure SetZipCastDir(const Value: String);
  public
    { Public declarations }
    Procedure ExecuteBatchMode( const Path, Filter: String; const SubFldr, ZipUp, ZipCast: Boolean );
  public
    Property BatchMode: Boolean Read FBatchMode Write SetBatchMode;
    Property ZipcastDir: String Read FZipCastDir Write SetZipCastDir;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
uses DirScan, SimpleUtils, IniFiles;

function TMainForm.ActOnFiles(const path: String;
  const SRec: TSearchRec): Boolean;
begin
  try
    // Originally I used the "Recycle files" function published
    //   by the JCL.  However, it took WAY too long...so I
    //   completly erase it instead.
    // One thing I've noticed:  "DeleteFile" will not work on readonly files
    DeleteFile( Path + '\' + SRec.Name );
    Result := True;
    Inc( FTotals );
    if FBatchMode then
      Application.Title := 'Cleanup: Total Deleted: ' + IntToStr( FTotals )
    else
      lbTotal.Caption := 'Total Deleted: ' + IntToStr( FTotals );
    Application.ProcessMessages;
  except
    Result := False;
  end;
end;

procedure TMainForm.DriveBoxChange(Sender: TObject);
begin
  DirectoryOutline.Drive := DriveBox.Drive;
end;

procedure TMainForm.btGoClick(Sender: TObject);
var
  tmpStr, tmpStr2: String;
  OldScr: TCursor;
begin
  OldScr := Screen.Cursor;
  try
    Screen.Cursor := crHourGlass;
    FTotals := 0;
    if cbFilter.Text = '' then
      Raise Exception.Create( 'Empty filter!' );
    tmpStr := cbFilter.Text;
    while Length( tmpStr ) > 0 do
      begin
        if Pos( ';', tmpStr ) > 0 then
          tmpStr2 := Copy( tmpStr, 1, Pos( ';', tmpStr )-1 )
        else
          begin
            tmpStr2 := tmpStr;
            tmpStr := '';
          end;
        DirScan.FindRecursive( DirectoryOutline.Directory, tmpStr2,
          ActOnFiles, cbIncludeSub.Checked );
        Delete( tmpStr, 1, Pos( ';', tmpStr ) );
      end;
    if Not( FBatchMode ) then
      MessageDlg('Total Files Recycled: ' + IntToStr(FTotals), mtInformation, [mbOK], 0);
    if cbZipdir.Checked then
      begin
        ZipDir;
        if Not( FBatchMode ) then
          MessageDlg('All operations finished.', mtInformation, [mbOK], 0);
        AppLabel.Caption := DirectoryOutline.Directory;
      end;
    if FBatchMode then
      Application.Title := 'Object File Cleanup'
    else
      lbTotal.Caption := '';
  finally
    Screen.Cursor := OldScr;
  end;
end;

procedure TMainForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  Indx: LongInt;
begin
  cbFilter.ItemIndex := 0;
  Self.Left := Screen.Width div 2 - ( Self.Width div 2 );
  Self.Top := Screen.Height div 2 - ( Self.Height div 2 );
  ReadFromIniFile;
  Indx := SimpleUtils.FindParameter( '/path' );
  if ( Indx > -1 ) and ( DirectoryExists( ParamStr(Indx+1) ) ) then
    begin
      MainForm.DriveBox.Drive := ParamStr(Indx+1)[1];
      MainForm.DirectoryOutline.Directory := ParamStr(Indx+1);
    end;
  Indx := SimpleUtils.FindParameter( '/zipcast' );
  if ( Indx > -1 ) and ( DirectoryExists( ParamStr(Indx+1) ) ) then
    ZipcastDir := ParamStr(Indx+1);
  Indx := SimpleUtils.FindParameter( '/batchmode' );
  if ( Indx > -1 ) and ( DirectoryExists( ParamStr(Indx+1) ) ) and ( ParamStr(Indx+2) <> '' ) and
    ( Indx+5 <= ParamCount ) then
      Self.ExecuteBatchMode( ParamStr(Indx+1), ParamStr(Indx+2),  // Director/Filter
        ( UpperCase(ParamStr(Indx+3))='TRUE' ),   // subdirectories
        ( UpperCase(ParamStr(Indx+4))='TRUE' ),   // Zipup
        ( UpperCase(ParamStr(Indx+5))='TRUE' ) ); // ZipCast
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := Self.OnHint;
end;

procedure TMainForm.cbFilterKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ( Key = VK_RETURN ) or ( Key = VK_TAB ) then
    begin
      cbFilter.Items.Add( cbFilter.Text );
      btGo.SetFocus;
    end;
end;

procedure TMainForm.ZipDir;
var
  tmpStr, tmpStr2: String;
begin
  tmpStr := LastDirName( DirectoryOutline.Directory ) + FileGetTodayOnString2 + '.ZIP';
  if UseZipcastFolder1.Checked and ( Length( FZipCastDir ) > 0 ) then
    ZipControl.ZipFilename := FZipCastDir + '\' + tmpStr
  else if PromptforZipcastFolder1.Checked then
    begin
      tmpStr2 := SimpleUtils.GetFolder( Self.Handle, 'Select the Zipcast folder' );
      if tmpStr2 <> '' then
        ZipControl.ZipFilename := tmpStr2 + '\' + tmpStr
      else
        ZipControl.ZipFilename := tmpStr
    end
  else
    ZipControl.ZipFilename := tmpStr;
  ZipControl.FSpecArgs.Add( DirectoryOutline.Directory + '\*.*' );
  if cbIncludeSub.Checked then
    ZipControl.AddOptions := [ AddDirNames, AddRecurseDirs ]
  else
    ZipControl.AddOptions := [ AddDirNames ];
  ZipControl.Add;
  if FBatchMode then
    Application.Title := 'Object File Cleanup'
  else
    AppLabel.Caption := '100%';
end;

procedure TMainForm.ZipControlProgress(Sender: TObject;
  ProgrType: ProgressType; Filename: String; FileSize: Integer);
begin
  if FBatchMode then
    Application.Title := 'Cleanup: Zipping ' + IntToStr( FileSize ) + ' K'
  else
    lbTotal.Caption := 'Zipping ' + IntToStr( FileSize ) + ' K';
  Application.ProcessMessages;
end;

procedure TMainForm.OnHint( Sender: TObject );
begin
  lbHint.Caption := Application.Hint;
end;

// I like INI Files... they are clean, easy to delete and play with.
//   I'm sure using the registry is faster, but I have cursed too
//   many programs that screwed up my registry to really like it.
procedure TMainForm.SaveToIniFile;
var
  Inf: TIniFile;
  x: LongInt;
begin
  Inf := TIniFile.Create( ExtractFilePath(Application.ExeName) + 'ObjectFileCleanup.ini' );
  try
    Inf.WriteString( 'ABOUT', 'PROGRAM_NAME', 'Object Cleaner' );
    Inf.WriteString( 'ABOUT', 'PROGRAM_VERSON', '1.04' );
    Inf.WriteString( 'ABOUT', 'PROGRAM_AUTHOR', 'Joseph Wilcock' );
    Inf.WriteString( 'ABOUT', 'PROGRAM_CONTACT', 'Coockoo@hotmail.com' );
    Inf.WriteString( 'ABOUT', 'PROGRAM_LAST_EDITED', 'September 17, 2001' );

    Inf.WriteBool( 'CONFIG', 'IncludeSub', cbIncludeSub.Checked );
    Inf.WriteBool( 'CONFIG', 'ZipDir', cbZipdir.Checked );
    Inf.WriteString( 'CONFIG', 'InitDrive', DriveBox.Drive );
    Inf.WriteString( 'CONFIG', 'InitDir', DirectoryOutline.Directory );

    Inf.WriteString( 'CONFIG', 'ZipCastDir', FZipCastDir );
    Inf.WriteBool( 'CONFIG', 'UseDefaultZipFolder', UseDefaultFolder1.Checked );
    Inf.WriteBool( 'CONFIG', 'UseZipcastFolder', UseZipcastFolder1.Checked );
    Inf.WriteBool( 'CONFIG', 'PromptforZipcastFolder', PromptforZipcastFolder1.Checked );

    Inf.WriteInteger( 'FILTER', 'COUNT', cbFilter.Items.Count-3 );
    for x := 3 to cbFilter.Items.Count-1 do
      Inf.WriteString( 'FILTER', 'Value' + IntToStr(x), cbFilter.Items[x] );
  finally
    Inf.Free;
  end;
end;

procedure TMainForm.ReadFromIniFile;
var
  Inf: TIniFile;
  x, Count: LongInt;
  tmpStr: String;
begin
  Inf := TIniFile.Create( ExtractFilePath(Application.ExeName) + 'ObjectFileCleanup.ini' );
  try
    cbIncludeSub.Checked := Inf.ReadBool( 'CONFIG', 'IncludeSub', False );
    cbZipdir.Checked := Inf.ReadBool( 'CONFIG', 'ZipDir', False );
    try
      DriveBox.Drive := Inf.ReadString( 'CONFIG', 'InitDrive', 'C' )[1];
      DirectoryOutline.Directory := Inf.ReadString( 'CONFIG', 'InitDir', '' );
    except
      DriveBox.Drive := 'C';
      DirectoryOutline.Directory := 'C:\';
    end;

    FZipCastDir := Inf.ReadString( 'CONFIG', 'ZipCastDir', '' );
    UseDefaultFolder1.Checked := Inf.ReadBool( 'CONFIG', 'UseDefaultZipFolder', True );
    UseZipcastFolder1.Checked := Inf.ReadBool( 'CONFIG', 'UseZipcastFolder', False );
    PromptforZipcastFolder1.Checked := Inf.ReadBool( 'CONFIG', 'PromptforZipcastFolder', False );

    Count := Inf.ReadInteger( 'FILTER', 'COUNT', 0 );
    for x := 0 to Count-1 do
      begin
        tmpStr := Inf.ReadString( 'FILTER', 'Value' + IntToStr(x), '' );
        if cbFilter.Items.IndexOF( tmpStr ) = -1 then
          cbFilter.Items.Add( tmpStr );
      end;
  finally
    Inf.Free;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveToIniFile;
end;

procedure TMainForm.SetBatchMode(const Value: Boolean);
begin
  FBatchMode := Value;
end;

procedure TMainForm.ExecuteBatchMode(const Path, Filter: String;
  const SubFldr, ZipUp, ZipCast: Boolean );
begin
  cbFilter.Text := Filter;
  DriveBox.Drive := Path[1];
  DirectoryOutline.Directory := Path;

  cbZipdir.Checked := ZipUp;
  cbIncludeSub.Checked := SubFldr;
  PromptforZipcastFolder1.Checked := False;
  UseDefaultFolder1.Checked := Not( ZipCast );
  UseZipcastFolder1.Checked := ZipCast;

  FBatchMode := True;
  btGoClick( Self );
  Close;
end;

procedure TMainForm.SetZipcastFolder1Click(Sender: TObject);
var
  tmpStr: String;
begin
  tmpStr := SimpleUtils.GetFolder( Self.Handle, 'Select the Zipcast folder.' );
  if tmpStr <> '' then
    FZipCastDir := tmpStr;
end;

procedure TMainForm.SetZipCastDir(const Value: String);
begin
  FZipCastDir := Value;
end;

procedure TMainForm.UseZipcastFolder1Click(Sender: TObject);
begin
  ( Sender as TMenuItem ).Checked := Not( ( Sender as TMenuItem ).Checked );
end;

function TMainForm.OnePerDir(const path: String;
  const SRec: TSearchRec): Boolean;
begin
  DirectoryOutline.Directory := Path + '\' + SRec.Name;
  ZipDir;
  Result := True;
end;

Procedure TMainForm.ZipupOnePerDir;
var
  Srch: TSearchRec;
  Err: LongInt;
  OrgDir: String;
begin
  OrgDir := DirectoryOutline.Directory;
  Err := SysUtils.FindFirst( OrgDir + '\*.*', faDirectory, Srch );
  while Err = 0 do
    begin
      if ( (Srch.Attr and faVolumeID) = 0 ) and ( Srch.Name <> '.' ) and ( Srch.Name <> '..' ) then
        OnePerDir( OrgDir, Srch );
      Err := SysUtils.FindNext( Srch );
    end;
  SysUtils.FindClose( Srch );
  DirectoryOutline.Directory := OrgDir;
end;

procedure TMainForm.Ziponefileperfolder1Click(Sender: TObject);
begin
  if PromptforZipcastFolder1.Checked then
    UseZipcastFolder1.Checked := True;
  ZipupOnePerDir;
end;

procedure TMainForm.Version1Click(Sender: TObject);
begin
  Application.MessageBox('  This is a simple tool to clean up directories based upon filters and then '+#13+#10+
    'zip up the folder for archiving.  It supports command-line paramters and '+#13+#10+
    'redirected zip-file output.'+#13+#10+
    '  This is freely give with full source code without any warrantee.  I just '+#13+#10+
    'ask that if you do make an improvement, please keep my name (Joseph Wilcock)'+#13+#10+
    'in the source and send a copy to me at Coockoo@hotmail.com.'+#13+#10+
    '  I used the Delphi version of the InfoZip source for the zipping functions.',
      'Object File Cleanup v1.04', MB_ICONINFORMATION );
end;

procedure TMainForm.CommandLineParameters1Click(Sender: TObject);
begin
MessageDlg('"/path {path value}" - To set the initial directory at startup.'+#13+#10+
           '"/zipcast {path value}" - To set the "Zipcast" folder.'+#13+#10+
           '"/batchmode {path value} {filter value} {recurse(True/False)} {zipup(True/False)} {zipcast(True/False)}"'+#13+#10+''+#13+#10+
           'All path values with spaces MUST be surrounded with quotes for the script or shortcut to work.', mtInformation, [mbOK], 0);
end;

end.
