unit SimpleUtils;

interface

{
   This was just a unit that I threw a few functions that I kept re-writing all
     the time.  Then I wised up and threw them into one folder.  It's as usefull
     as anything else, I suppose.   If you do use them in something I'd love
     to hear from you!

Joseph Wilcock
Coockoo@hotmail.com
http://msnhomepages.talkcity.com/RedmondAve/coockoo/

}


uses Windows;

Function UtilDateToDateTime( const TodayDate: String ): TDateTime;
Function GetTodayOnString: String;
Function FileUtilDateToDateTime( const TodayDate: String ): TDateTime;
Function FileGetTodayOnString: String;
Function FileGetTodayOnString2: String;
Function LastDirName( Directory: String ): String;
Function CleanFolder(Path: String): Boolean;
Function UniquePath( Path: String ): String;
Function GetFolder( aHandle: THandle; Caption: String ): String;
Function FindParameter( Parameter: String ): LongInt;

implementation

uses SysUtils, FileCtrl, ShlObj;

Function MonthToNumber( const Value: String ): Integer;
begin
  if Value = 'January' then
    Result := 1
  else if Value = 'Febuary' then
    Result := 2
  else if Value = 'March' then
    Result := 3
  else if Value = 'April' then
    Result := 4
  else if Value = 'May' then
    Result := 5
  else if Value = 'June' then
    Result := 6
  else if Value = 'July' then
    Result := 7
  else if Value = 'August' then
    Result := 8
  else if Value = 'September' then
    Result := 9
  else if Value = 'October' then
    Result := 10
  else if Value = 'November' then
    Result := 11
  else if Value = 'December' then
    Result := 12
  else
    Result := 0;
end;

Function UtilDateToDateTime( const TodayDate: String ): TDateTime;
var
  tmpStr1, tmpStr2: String;
begin
  try
    tmpStr1 := TodayDate;
    tmpStr2 := Copy( tmpStr1, Pos( ',', tmpStr1 )+2, Length( tmpStr1 ) );
    tmpStr2 := Copy( tmpStr2, 1, Pos( '-', tmpStr2 )-3 );
    tmpStr1 := Copy( tmpStr2, 1, Pos( ' ', TmpStr2 )-1 );
    Delete( tmpStr2, 1, Pos( ' ', tmpStr2 ) );
    tmpStr2 := IntToStr( MonthToNumber( tmpStr1 ) ) + '/' + tmpStr2;
    Delete( tmpStr2, Pos( ' ', tmpStr2 ), 1 );
    tmpStr2[ Pos( ',', tmpStr2 ) ] := '/';
    Result := StrToDateTime( tmpStr2 );
  except
    Result := StrToDateTime( '1/1/2000' );
  end;
end;

Function GetTodayOnString: String;
begin
  Result := FormatDateTime( 'dddd, mmmm d, yyyy, - hh:mm AM/PM', Now );
end;

Function FileUtilDateToDateTime( const TodayDate: String ): TDateTime;
var
  tmpStr1, tmpStr2: String;
  tmpMonth: Integer;
begin
  try
    tmpStr1 := TodayDate;
    tmpStr2 := Copy( tmpStr1, Pos( '_', tmpStr1 )+1, Length( tmpStr1 ) );
    tmpStr1 := Copy( tmpStr2, 1, Pos( '_', TmpStr2 )-1 );
    Delete( tmpStr2, 1, Pos( '_', tmpStr2 ) );
    tmpMonth := MonthToNumber( tmpStr1 );
    if ( tmpMonth < 1 ) or ( tmpMonth > 12 ) then
      tmpMonth := 1;
    tmpStr2 := IntToStr( tmpMonth ) + '/' + tmpStr2;
    tmpStr2[ Pos( '_', tmpStr2 ) ] := '/';
    Result := StrToDateTime( tmpStr2 );
  except
    Result := StrToDateTime( '1/1/2000' );
  end;
end;

Function FileGetTodayOnString: String;
begin
  Result := FormatDateTime( 'dddd_mmmm_d_yyyy', Now );
end;

Function FileGetTodayOnString2: String;
begin
  Result := FormatDateTime( 'ddmmmyyyy_hhmmAMPM', Now );
end;

Function LastDirName( Directory: String ): String;
begin
  Result := Directory;
  if Pos( ':', Result ) <> 0 then
    Delete( Result, 1, Pos( ':', Result ) );
  if ( Length( Result ) > 0 ) and ( Result[ Length( Result ) ] = '\' ) then
    Delete( Result, Length(Result), 1 );
  while Pos( '\', Result ) > 0 do
    Delete( Result, 1, Pos( '\', Result ) );
  if Length( Result ) = 0 then
    Result := 'Root';
end;

Function CleanFolder(Path: String): Boolean;
var
  Srch: TSearchRec;
  Err: LongInt;
begin
  Err := SysUtils.FindFirst( Path + '\*.*', faAnyFile, Srch );
  While Err = 0 do
    begin
      if ( Srch.Attr and faVolumeID = 0 ) then
        begin
          if Srch.Attr and faReadOnly = faReadOnly then
            FileSetAttr( Path + '\' + Srch.Name, Srch.Attr and faReadOnly );
          if ( Srch.Attr and faDirectory = 0 ) then
            begin
              try
                Result := SysUtils.DeleteFile( Path + '\' + Srch.Name );
              except end;
            end
          else if ( Srch.Attr and faDirectory = faDirectory ) and
          ( Srch.Name <> '.' ) and ( Srch.Name <> '..' ) then
            begin
              CleanFolder( Path + '\' + Srch.Name );
              try
                  {$I-}
                RmDir( Path + '\' + Srch.Name );
                  {$I+}
              except end;
            end;
        end;
      Err := SysUtils.FindNext( Srch );
    end;
  SysUtils.FindClose( Srch );
end;

Function UniquePath( Path: String ): String;
var
  tmpInt: Integer;
begin
  Result := Path;
  tmpInt := 1;
  while DirectoryExists( Result ) do
    begin
      Result := Path + ' (' + IntToStr(tmpInt) + ')';
      Inc( tmpInt );
    end;
end;

Function GetFolder( aHandle: THandle; Caption: String ): String;
var
  BrowseInfo: TBrowseInfo;
  PIDL: PItemIDList;
  DisplayName: Array[0..MAX_PATH] of Char;
begin
  // this is an interesting way to do it, but DON'T do this to a pointer
  //   ....it turns it null....
  FillChar( BrowseInfo, SizeOF(BrowseInfo), #0 );
  with BrowseInfo do
    begin
      hwndOwner := aHandle;
      pszDisplayName := @DisplayName[0];
      lpszTitle := @Caption[1];
      ulFlags := BIF_RETURNONLYFSDIRS;
    end;
  PIDL := ShlObj.SHBrowseForFolder( BrowseInfo );
  Result := '';
  if Assigned( PIDL ) then
    begin
      if ShlObj.SHGetPathFromIDList( PIDL, Displayname ) then
        Result := StrPas( DisplayName );
      GlobalFreePtr(PIDL);
    end;
end;

Function FindParameter( Parameter: String ): LongInt;
var
  x: LongInt;
  tmpStr: String;
begin
  Result := -1;
  for x := 1 to ParamCount-1 do
    begin
    tmpStr := ParamStr(x);
    if ( Pos( UpperCase( Parameter ), UpperCase( tmpStr{ParamStr(x)} ) ) = 1 ) then
      Result := x;
    end;
end;

end.
